Program mat_vect_prod
   implicit none
   integer, parameter :: n=500
   real(kind(1.d0)), dimension(n,n)   :: a, b, c
   integer            :: i, j, k

   call random_number(a)
   call random_number(b)
   c = 0.d0

!$omp parallel do 
   do j=1, n
      do k=1, n
         do i=1, n
            c(i,j) = c(i,j) + a(i,k)*b(k,j)
         end do
      end do
   end do

   write(*,*) maxval(abs(c-matmul(a,b)))

end program mat_vect_prod
