c--------------------------------------------c
c  Example: simple data type                 c
c  Send and Receive an Integer Data          c
c  Send and Receive a  Double Precision Data c
c  Send and Receive an Array of Integers     c
c--------------------------------------------c


      program main


      implicit none

      include 'mpif.h'
      integer ierr,rank,size

      integer i,j
      integer status(MPI_STATUS_SIZE)


c--- data to communicate------------------------------------------------------
      integer MSIZE
      parameter (MSIZE=10)
      integer data_int
      double precision data_double
      double precision matrix(MSIZE,MSIZE)



c--- Start up MPI  ----------- -----------------------------------------------

c ---> INSERT MPI code

c--- Check number of processes ----------------------------------------------

      if (size.lt.2) then
         if (rank.eq.0) print *, 'SORRY: need at least 2 processes'

c--- exit MPI on error ------------------------------------------------------
         call MPI_FINALIZE(ierr)
         stop

      endif

c--- INTEGER TYPE -----------------------------------------------------------

      if (rank.eq.0) then

         data_int = 10
c ---> INSERT MPI code

      end if
      if (rank.eq.1) then
c ---> INSERT MPI code

         print *,'Proc 1 receives ',data_int,'from proc 0'
         print *,' '
      endif

c---  ARRAY OF DOUBLE TYPE  --------------------------------------------------

      if (rank.eq.0) then

         do i=1,MSIZE
            do j=1,MSIZE
               matrix(i,j)= dble(i+j)
            enddo
         enddo
c ---> INSERT MPI code

      end if

      if (rank.eq.1) then
c ---> INSERT MPI code

         print *,'Proc 1 receives the following matrix from proc 0'
         write (*,'(10(f6.2,2x))') matrix
      endif

c--- QUIT --------------------------------------------------------------------
c ---> INSERT MPI code
            
      end
