c------------------------------------------c
c Exercise: Circular Shift non-blocking
c
c In this exercise you will communicate a matrix 
c among process in a circular topology, so that
c every process has a left and a right neighbor
c to receive and to send data respectivelly.
c
c Resolve deadlocks with non-blocking MPI function
c------------------------------------------c

      program main


      implicit none

      include 'mpif.h'
      integer i
      integer ierr,rank,size
      integer tag,from,to
      integer MSIZE
      parameter(MSIZE=50000)
      integer A(MSIZE),B(MSIZE)

      integer status(MPI_STATUS_SIZE)
      integer request
      
      
c--- Start up MPI  ----------- ----------------------------------------------
c ---> INSERT MPI code

c----- print banner --------------------------------------------------------c
      if (rank.eq.0) then
         print *
     $        ,'Circular shift example: each process fills matrix A' 
         print *
     $        ,'elements with its rank and sends them to the right'
         
         print *,'process which receives them into matrix B'
         print *

      endif
    
c---------------------------------------------------------------------------c
c    Arbitrarily choose 201 to be our tag. Calculate the rank of the        c
c    to process. Use the modulus operator so that the                     c
c    last process "wraps around" to rank zero.                              c
c---------------------------------------------------------------------------c

c ---> INSERT code
      tag=
      to = 
      from = 

      do i=1,MSIZE
         A(i)=rank
      enddo 

c---  starting non blocking send of array A  ----------------------------


c ---> INSERT MPI code

      print '(a4,2x,i2,2x,a8,2x,i5,2x,a18,2x,i4)','Proc',rank,'sends'
     $     ,MSIZE,'integers to proc',to

c---  starting blocking receives of array A in B -----------------------

     
c ---> INSERT MPI code

      print '(a4,2x,i2,2x,a8,2x,i5,2x,a18,2x,i4)','Proc',rank,'receives'
     $     ,MSIZE,'integers from proc',from


c---  Wait for completition --------------------------------------------
c ---> INSERT MPI code

c--- print first content of array A and B -----------------------------------

      print '(a4,2x,i2,2x,a10,2x,i2,2x,a10,i2)','Proc',rank,'has A(1) ='
     $     ,A(1),' and B(1) =',B(1)
      print *,'******************************************'

c--- QUIT -------------------------------------------------------------------
      
c ---> INSERT MPI code
      
      end
